// line 159 "CachingMethodCall.jweb"
/*;
Copyright (c) 1998 The Omega Project for Statistical Computing.  
All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. All advertising materials mentioning features or use of this
    software must display the following acknowledgment:
    "This product includes software developed by the Omega Project for
    Statistical Computing ."

 4. The name "Omega Project for Statistical Computing" must not be used to
    endorse or promote products derived from this software without
    prior written permission.

 5. Redistributions of any form whatsoever must retain the following
    acknowledgment:
    "This product includes software developed by the Omega Project
    for Statistical Computing."

 THIS SOFTWARE IS PROVIDED BY THE OMEGA PROJECT FOR STATISTICAL
 COMPUTING ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE OMEGA PROJECT FOR STATISTICAL COMPUTING OR ITS
 CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/
// line 11 "CachingMethodCall.jweb"
//package org.omegahat.Environment.Parser.Parse;
package org.omegahat.Simulation.MCMC.Expressions;

// line 147 "CachingMethodCall.jweb"
    import org.omegahat.Simulation.MCMC.*;
    import org.omegahat.Simulation.MCMC.Listeners.*;
    import org.omegahat.Simulation.MCMC.Proposals.*;
    import org.omegahat.Simulation.MCMC.Targets.*;

import org.omegahat.Environment.Parser.Parse.*;
import java.lang.reflect.Method;
import org.omegahat.Environment.Interpreter.Evaluator;



// line 15 "CachingMethodCall.jweb"
public class CachingMethodCall extends MethodCall {

// line 26 "CachingMethodCall.jweb"
protected Object cachedObject   = null;
protected Method cachedMethod   = null;


// line 33 "CachingMethodCall.jweb"
public Method cachedMethod() { return cachedMethod; }
public Method cachedMethod( Method cachedMethod ) { return this.cachedMethod = cachedMethod; }

public Object cachedObject() { return cachedObject; }
public Object cachedObject( Object cachedObject ) { return this.cachedObject = cachedObject; } 


/* If someone changes the qualifier, our cached values will no longer be valid, so set them to null */
public ExpressionInt qualifier( ExpressionInt qualifier )
{
  cachedMethod(null);
  cachedObject(null);
  return super.qualifier(qualifier);
}

/*  If someone changes the element, our cached method will no longer be valid, so set it to null */

public String elementName( String elementName )
{
  cachedMethod(null);
  return super.elementName(elementName);
}

// line 60 "CachingMethodCall.jweb"
public CachingMethodCall(Name n, List list) {
 super(n,list);
}

public CachingMethodCall(ExpressionInt qualifier, String name, List list) {
  super(qualifier, name, list);
}

public CachingMethodCall(ExpressionInt qualifier, List list) {
  super(qualifier, list);
}

public CachingMethodCall(String name, List list) {
 super(name, list);
}


public CachingMethodCall(String name, String[] argNames) {
  super(name, argNames);
}



// line 113 "CachingMethodCall.jweb"
//
// overrides method provided in MethodCall so that we can cache the resolved object and method.
//
public Object findEvalMethod(List l, Object source, Evaluator evaluator, boolean implicitNew ) throws Throwable 
{

 // Evaluate the arguments.
 Object arguments[] = null;
 if(l != null)
 arguments = l.toArray();

 Method m = null;

 // resolve the method  ( may be null )
 try 
 {
   m = resolveMethod( arguments, source, evaluator );
 }
 catch (Throwable t)
 {
   // if we get an error, try the normal way...
   m = null;
 }

 // store the resolved object and method for next time
 cachedObject(source);
 cachedMethod(m);

 return super.findEvalMethod(l, source, evaluator, implicitNew); 
}

// line 20 "CachingMethodCall.jweb"
}

